unit Unit1;

interface

uses
	Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
	System.Classes, Vcl.Graphics,
	Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Math2D, Ship, EntityManager,
	Vcl.ExtCtrls, Math, Vcl.StdCtrls;

type
	TForm1 = class(TForm)
		Image1: TImage;
		Timer1: TTimer;
		procedure FormCreate(Sender: TObject);
		procedure Timer1Timer(Sender: TObject);
		procedure FormClose(Sender: TObject; var Action: TCloseAction);
		procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
			MousePos: TPoint; var Handled: Boolean);
		procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
			MousePos: TPoint; var Handled: Boolean);
	private
		{ Private declarations }
	public
		{ Public declarations }
	end;

var
	Form1: TForm1;
	S: TShip;
	A: TAsteroid;
	EM: TEntityManager;
	kUP, kDOWN, kLEFT, kRIGHT, kFIRE: Boolean;
	KBHook: HHook;

function KeyboardHookProc(Code: Integer; WordParam: Word; LongParam: LongInt)
	: LongInt; stdcall;

implementation

{$R *.dfm}

function KeyboardHookProc(Code: Integer; WordParam: Word;
	LongParam: LongInt): LongInt;
begin
	case WordParam of
		Ord('W'):
			if GetKeyState(Ord('W')) < 0 then
				kUP := True
			else
				kUP := False;
		Ord('S'):
			if GetKeyState(Ord('S')) < 0 then
				kDOWN := True
			else
				kDOWN := False;
		Ord('A'):
			if GetKeyState(Ord('A')) < 0 then
				kLEFT := True
			else
				kLEFT := False;
		Ord('D'):
			if GetKeyState(Ord('D')) < 0 then
				kRIGHT := True
			else
				kRIGHT := False;
		VK_SPACE:
			if GetKeyState(VK_SPACE) < 0 then
				kFIRE := True
			else
				kFIRE := False;
	end;
	Result := 0;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	UnHookWindowsHookEx(KBHook);
	FreeAndNil(S);
	FreeAndNil(A);
	FreeAndNil(EM);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	KBHook := SetWindowsHookEx(WH_KEYBOARD, @KeyboardHookProc, HInstance,
		GetCurrentThreadId);

	S := TShip.Create(PointF(Image1.Width / 2, Image1.Height / 2), 270, 0.2,
		nil, 100, 0);
	S.Dimensions := [Line2D(120, 0, -40, 60), Line2D(-20, 60, -10, 0),
		Line2D(-10, 0, -40, -60), Line2D(-40, -60, 120, 0)];

	A := TAsteroid.Create(PointF(200, 200), 45, 5, nil);
	A.Dimensions := [Line2D(0, -2, 3, -1), Line2D(3, -1, -5, 5),
		Line2D(-5, 5, -15, 0), Line2D(-15, 0, -10, -15), Line2D(-10, -15, 0, -2)];
	EM := TEntityManager.Create;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
	MousePos: TPoint; var Handled: Boolean);
begin
	if S.Scale >= 0.1 then
		S.Scale := S.Scale - 0.1;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
	MousePos: TPoint; var Handled: Boolean);
begin
	S.Scale := S.Scale + 0.1;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
	I, J: Integer;
	EP, Inter: TPointF;
	D: Double;
begin
	if S <> nil then
	begin
  	//DRAWING
		PatBlt(Image1.Canvas.Handle, 0, 0, Image1.Width, Image1.Height, WHITENESS);

		Image1.Canvas.Pixels[round(S.Pos.X), round(S.Pos.Y)] := clBlack;
		Image1.Canvas.MoveTo(round(S.Polygon[0].x1), round(S.Polygon[0].y1));
		for I := Low(S.Polygon) to High(S.Polygon) do
			Image1.Canvas.LineTo(round(S.Polygon[I].x2), round(S.Polygon[I].y2));

		Image1.Canvas.Pixels[round(A.Pos.X), round(A.Pos.Y)] := clBlack;
		Image1.Canvas.MoveTo(round(A.Polygon[0].x1), round(A.Polygon[0].y1));
		for I := Low(A.Polygon) to High(A.Polygon) do
		begin
			Image1.Canvas.LineTo(round(A.Polygon[I].x1), round(A.Polygon[I].y1));
			Image1.Canvas.LineTo(round(A.Polygon[I].x2), round(A.Polygon[I].y2));
		end;
    //DRAWING
		for I := Low(A.Polygon) to High(A.Polygon) do
		begin
			Image1.Canvas.Ellipse(round(A.Polygon[I].x1 - 3),
				round(A.Polygon[I].y1 - 3), round(A.Polygon[I].x1 + 3),
				round(A.Polygon[I].y1 + 3));
			Image1.Canvas.Ellipse(round(A.Polygon[I].x2 - 3),
				round(A.Polygon[I].y2 - 3), round(A.Polygon[I].x2 + 3),
				round(A.Polygon[I].y2 + 3));
		end;

    //ROTATING ASTEROID
		A.Angle := A.Angle + 0.5;

    //FOR KEYBOARD HOOK
		if not Application.Active then
		begin
			kUP := False;
			kDOWN := False;
			kLEFT := False;
			kRIGHT := False;
		end;

    //MOVEMENT
		if kLEFT then
			S.Angle := S.Angle - 1;

		if kRIGHT then
			S.Angle := S.Angle + 1;

		if kUP then
			S.Pos := PointOfAngle(S.Pos.X, S.Pos.Y, 3, S.Angle);

		if kDOWN then
			S.Pos := PointOfAngle(S.Pos.X, S.Pos.Y, 3, S.Angle - 180);

    //FIRING BULLETS
		if kFIRE and (EM <> nil) then
		begin
			EM.Add(S.Pos, PointOfAngle(S.Pos.X, S.Pos.Y, 500, S.Angle + 0.0000000001),
				S.Angle + 0.0000000001, 500, 0.5);
		end;

    //DRAWING
		if (EM <> nil) and (EM.Entities.Count > 0) then
		begin
			EM.Update;
			for I := 0 to EM.Entities.Count - 1 do
			begin
				Image1.Canvas.Pen.Color := clRed;
				Image1.Canvas.Ellipse(round(EM.Entities[I].Pos.X - 1),
					round(EM.Entities[I].Pos.Y - 1), round(EM.Entities[I].Pos.X + 1),
					round(EM.Entities[I].Pos.Y + 1));
				Image1.Canvas.MoveTo(round(EM.Entities[I].Pos.X),
					round(EM.Entities[I].Pos.Y));
				EP := PointOfAngle(EM.Entities[I].Pos.X, EM.Entities[I].Pos.Y, 7,
					EM.Entities[I].Angle);
				Image1.Canvas.LineTo(round(EP.X), round(EP.Y));
				Image1.Canvas.Pen.Color := clBlack;
			end;
		end;

    //COLLISION DETECTION
		for I := 0 to EM.Entities.Count - 1 do
			for J := Low(A.Polygon) to High(A.Polygon) do
				if LinesIntersect(A.Polygon[J].x1, A.Polygon[J].y1, A.Polygon[J].x2,
					A.Polygon[J].y2, EM.Entities[I].Pos.X, EM.Entities[I].Pos.Y,
					EM.Entities[I].Pos.X + EM.Entities[I].xSpeed,
					EM.Entities[I].Pos.Y + EM.Entities[I].ySpeed, Inter) then
				begin
					EM.Entities[I].Pos := Inter;
					EM.Entities[I].Target := Inter;
				end;

	end;
end;

end.
